<!--
title: Handleiding container based challenges
description: 
published: true
date: 2021-12-20T15:42:47.939Z
tags: 
editor: ckeditor
dateCreated: 2021-12-20T15:41:22.250Z
-->

<h1>Handleiding container based challenges&nbsp;</h1>
<h2>Requirements</h2>
<p>Om een challenge te bouwen zijn de volgende requirements:</p>
<p>Docker | <a href="https://www.docker.com/products/docker-desktop">Docker Desktop for Mac and Windows | Docker</a> | <a href="https://minikube.sigs.k8s.io/docs/">Welcome! | minikube (k8s.io)</a></p>
<p>Kubernetes | <a href="https://kubernetes.io/docs/concepts/overview/what-is-kubernetes/">What is Kubernetes? | Kubernetes</a> | <a href="https://birthday.play-with-docker.com/kubernetes-docker-desktop/">Getting Started with Kubernetes on Docker Desktop (play-with-docker.com)</a></p>
<p>Kompose | <a href="https://kompose.io/">Kubernetes + Compose = Kompose</a></p>
<h2>Docker-compose</h2>
<h3>Eisen</h3>
<p>Geen persistent volumes | <a href="https://kubernetes.io/docs/concepts/storage/persistent-volumes/">Persistent Volumes | Kubernetes</a></p>
<p>Secrets in environment variabelen | <a href="https://kubernetes.io/docs/tasks/inject-data-application/define-environment-variable-container/">Define Environment Variables for a Container | Kubernetes</a></p>
<p>Documentatie over de uitrol van de omgeving<br>Wat vereist jouw gemaakte omgeving.</p>
<p>Documentatie over het gebruik van de omgeving<br>Waar worden vlaggen geplaatst. Wat moet worden gedaan op de omgeving.</p>
<h3>Persistentie van volumes bereiken</h3>
<p>Maak een Docker image waar alle bestanden op de juiste plaats staan en zet vervolgens deze image op een docker registry (het voorbeeld maakt gebruik van docker hub).</p>
<p>Stap 1 is het maken van een Dockerfile. Het onderstaande is een voorbeeld.</p>
<pre><code class="language-plaintext">FROM wordpress
COPY . /var/www/html</code></pre>
<p>Let op! Bij ontwikkelen op Windows zijn bestanden gemaakt in Windows met line-ending CRLF. Bestanden die gekopieërd worden naar de container moeten omgezet worden naar line ending format voor Linux, dat is LF.</p>
<p>Het bouwen en pushen van een Docker image is te doen met de volgende commando’s (<code>mvdb010</code> is een user op <code>dockerhub.com</code>).</p>
<pre><code class="language-plaintext">docker build -t mvdb0110/mkb-wordpress:latest .
docker push mvdb0110/mkb-wordpress:latest</code></pre>
<p>Om deze image lokaal te laten draaien als container, gebruik het volgende commando. De optie <code>-d</code> staat voor daemon of detached mode, en de optie <code>-p</code> zorgt voor de portmapping.</p>
<p><code>docker run -d -p 8080:80 mvdb0110/mkb-wordpress:latest</code></p>
<p>Hierna kan de wordpress server worden bereikt via <code>http://localhost:8080</code>.</p>
<p>Voor meer informatie over Docker images wordt verwezen naar <a href="https://codefresh.io/docker-tutorial/build-docker-image-dockerfiles/">Building Docker Images with Dockerfiles - Codefresh</a>.</p>
<h3>Voorbeeld docker-compose</h3>
<p>Docker-compose maakt het mogelijk meerdere services, met een intern netwerk, tegelijk aan te maken. Een werkend voorbeeld van docker-compose is hieronder te vinden. Maak de file <code>docker-compose.yml</code> met deze inhoud.</p>
<p>&nbsp;</p>
<pre><code class="language-plaintext">version: '3.3'

services:
   db:
     image: mysql:5.7
     ports:
       - "3306:3306"
     restart: always
     environment:
       MYSQL_ROOT_PASSWORD: this_is_very_secure
       MYSQL_DATABASE: wordpress
       MYSQL_USER: wordpress
       MYSQL_PASSWORD: this_is_very_secure

   wordpress:
     depends_on:
       - db
     image: wordpress:latest
     ports:
       - "81:80"
     restart: always
     environment:
       WORDPRESS_DB_HOST: db:3306
       WORDPRESS_DB_USER: wordpress
       WORDPRESS_DB_PASSWORD: this_is_very_secure
       WORDPRESS_DB_NAME: wordpress</code></pre>
<p>Vervolgens kunnen met het commando</p>
<pre><code class="language-plaintext">docker-compose up</code></pre>
<p>deze services worden opgestart. De WordPress server is nu bereikbaar onder <code>http://localhost:81</code>.</p>
<p>Een uitgebreidere versie:</p>
<pre><code class="language-plaintext">version: "3.2"

services:

    mariadb:
        # De image verwijst naar de aangemaakte docker image in een publieke docker registry
        image: mvdb0110/mkb-mariadb:latest
        # De container_name is belangrijk voor het verbinden met andere componenten.
        # Deze naam wordt namelijk straks de DNS naam.
        container_name: mariadb
        # Deze zijn extreem belangrijk, want dit maakt de daadwerkelijke service aan, zodat de componenten elkaar kunnen bereiken.
        ports: 
            - 3306:3306
        # Dit zijn de variabelen die aan de image mee worden gegeven bij deployment.
        environment: 
            - MYSQL_DATABASE=mariadb
            - MYSQL_USER=mariadb
            - MYSQL_PASSWORD=mariadb
            - MYSQL_ROOT_PASSWORD=321verysecurerootpassword123

    wordpress: 
        depends_on: 
            - mariadb
        image: mvdb0110/mkb-wordpress:latest
        container_name: wordpress
        links:
            - 'mariadb:mysql'
        ports: 
            - 80:80
        environment: 
            - WORDPRESS_DB_NAME=wordpress
            - WORDPRESS_DB_USER=root
            - WORDPRESS_DB_HOST=mariadb
            - WORDPRESS_DB_PASSWORD=321verysecurerootpassword123
            - WORDPRESS_CONFIG_EXTRA=define( 'WP_HOME', 'http://localhost' );define( 'WP_SITEURL', 'http://localhost' );
    firefly: 
        depends_on: 
            - mariadb
        image: jc5x/firefly-iii:latest
        container_name: firefly
        ports: 
            - 80:8080
        environment: 
            - APP_KEY=dRZ1lRipw1htgeanQrmjRcD3PGGJjvlk
            - DB_CONNECTION=mysql
            - DB_DATABASE=firefly
            - DB_USERNAME=root
            - DB_PASSWORD=321verysecurerootpassword123
            - DB_HOST=mariadb
            - DB_PORT=3306

    orangehrm:
        depends_on: 
            - mariadb
        image: mvdb0110/orangehrm:latest
        container_name: orangehrm
        ports: 
            - 80:8080
        environment: 
            - ORANGEHRM_DATABASE_NAME=orangehrm
            - ORANGEHRM_DATABASE_USER=root
            - ORANGEHRM_DATABASE_PASSWORD=321verysecurerootpassword123
            - ORANGEHRM_USERNAME=orangehrmuser
            - ORANGEHRM_PASSWORD=orangehrmpassword
    
    backup:
        depends_on:
            - mariadb
        container_name: backup
        image: mvdb0110/mkb-backups:latest
        links:
            - mariadb
        environment:
            - DB_SERVER=mariadb
            - DB_NAME=mariadb
            - DB_USER=root
            - DB_PASSWORD=321verysecurerootpassword123
            - DB_DUMP_FREQ=1440
            - DB_DUMP_BEGIN=1410
            - MD5=FALSE
            - COMPRESSION=GZ
            - SPLIT_DB=TRUE</code></pre>
<p>&nbsp;</p>
<h3>Uitvoeren van docker-compose in Kubernetes</h3>
<p>Wanneer de challenge gemaakt is in docker-compose vragen wij om deze om te zetten naar Kubernetes. Dit kan bij een volgens richtlijnen opgestelde docker-compose.yml met de tool kompose. <a href="https://kompose.io/user-guide/">User Guide (kompose.io)</a></p>
<figure class="table">
  <table>
    <tbody>
      <tr>
        <th>&nbsp;</th>
        <th><strong>Stap</strong></th>
        <th><strong>File</strong></th>
        <th><strong>Input</strong></th>
      </tr>
      <tr>
        <th>1</th>
        <th>Open Terminal</th>
        <th>n.v.t.</th>
        <th>&nbsp;</th>
      </tr>
      <tr>
        <th>2</th>
        <th>Maak map en verander je werkmap</th>
        <th><code>~\Desktop\kompose</code></th>
        <th>mkdir ~\Desktop\kompose
          cd ~\Desktop\kompose</th>
      </tr>
      <tr>
        <th>3</th>
        <th>Plaats valide docker-compose bestand in de map</th>
        <th>docker-compose.yml</th>
        <th>mv \path\to\docker-compose.yml ~\Desktop\kompose\&nbsp;</th>
      </tr>
      <tr>
        <th>4</th>
        <th>Converteer docker-compose met de tool kompose.</th>
        <th>docker-compose.yml</th>
        <th>kompose convert</th>
      </tr>
      <tr>
        <th>5</th>
        <th>Test de Kubernetes files.</th>
        <th>Output vorige commando</th>
        <th>kubectl apply -f . -n namespace</th>
      </tr>
      <tr>
        <th>6</th>
        <th>Kijk welke services inmiddels zijn opgestart</th>
        <th>&nbsp;</th>
        <th>kubectl get services</th>
      </tr>
      <tr>
        <th>7</th>
        <th>Open een lokale poort voor verkeer van een aangemaakte Kubernetes service.</th>
        <th>n.v.t.</th>
        <th>kubectl port-forward service/servicename local:remote -n namespace</th>
      </tr>
      <tr>
        <th>8</th>
        <th>Open verkeer voor de service op de lokale poort.</th>
        <th>n.v.t.</th>
        <th>&nbsp;</th>
      </tr>
    </tbody>
  </table>
</figure>
<p>&nbsp;</p>
